package common.sound;

import common.entity.item.EntityCart;
import common.init.SoundEvent;
import common.util.ExtMath;

public class MovingSoundMinecart extends MovingSound
{
    private final EntityCart minecart;
    private float distance = 0.0F;

    public MovingSoundMinecart(EntityCart minecartIn)
    {
        super(SoundEvent.CART);
        this.minecart = minecartIn;
        this.repeat = true;
    }

    /**
     * Like the old updateEntity(), except more generic.
     */
    public void update()
    {
        if (this.minecart.dead)
        {
            this.donePlaying = true;
        }
        else
        {
            this.xPosF = (float)this.minecart.posX;
            this.yPosF = (float)this.minecart.posY;
            this.zPosF = (float)this.minecart.posZ;
            float f = ExtMath.sqrtd(this.minecart.motionX * this.minecart.motionX + this.minecart.motionZ * this.minecart.motionZ);

            if ((double)f >= 0.01D)
            {
                this.distance = ExtMath.clampf(this.distance + 0.0025F, 0.0F, 1.0F);
                this.volume = 0.0F + ExtMath.clampf(f, 0.0F, 0.5F) * 0.7F;
            }
            else
            {
                this.distance = 0.0F;
                this.volume = 0.0F;
            }
        }
    }
}
